#!/bin/sh

export INSERT_HTL=0

ksk=`date +%y-%m-%d_%H:%M:%S`_$$
cat >metadata <<__EOF__
Version
Revision=1
EndPart
Document
Info.Format=text/html
End
__EOF__

rm -f sskfile
../ssktool/ssktool --genkeys && \
  echo "ssktool --genkeys running without sskfile!" && exit 1
../ssktool/ssktool --sskfile sskfile --genkeys
../ssktool/ssktool --sskfile sskfile --genkeys && \
  echo "ssktool --genkeys willing to overwrite sskfile!" && exit 1

../ssktool/ssktool \
	      --redirect freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF && \
  echo "ssktool --redirect running without sskfile!" && exit 1
../ssktool/ssktool --sskpath sskpath \
	      --redirect freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF && \
  echo "ssktool --redirect running with sskpath only!" && exit 1
../ssktool/ssktool --sskfile sskfile \
	      --redirect freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF && \
  echo "ssktool --redirect running without sskpath!" && exit 1
../ssktool/ssktool --sskfile sskfile --sskpath test/1 \
		   --redirect freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF

../ssktool/ssktool --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF && \
  echo "ssktool --dbr running without sskfile!" && exit 1
../ssktool/ssktool --sskpath sskpath \
		   --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF && \
  echo "ssktool --dbr running with sskpath only!" && exit 1
../ssktool/ssktool --sskfile sskfile \
		   --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF && \
  echo "ssktool --dbr running without sskpath!" && exit 1
../ssktool/ssktool --sskfile sskfile --sskpath test/2 \
		   --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF
../ssktool/ssktool --sskfile sskfile --sskpath test/3 --dbr-offset=12d \
		   --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF
../ssktool/ssktool --sskfile sskfile --sskpath test/4 --dbr-offset=12h \
		   --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF
../ssktool/ssktool --sskfile sskfile --sskpath test/5 --dbr-offset=12 \
		   --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF
../ssktool/ssktool --sskfile sskfile --sskpath test/6 --dbr-increment=12d \
		   --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF
../ssktool/ssktool --sskfile sskfile --sskpath test/7 --dbr-increment=12h \
		   --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF
../ssktool/ssktool --sskfile sskfile --sskpath test/8 --dbr-increment=12 \
		   --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF

../ssktool/ssktool --insert sskfile && \
  echo "ssktool --insert running without sskfile, path and key!" && exit 1
../ssktool/ssktool --insert sskfile --sskfile sskfile && \
  echo "ssktool --insert running without sskpath and key!" && exit 1
../ssktool/ssktool --insert sskfile --sskpath sskfile && \
  echo "ssktool --insert running without sskfile and key!" && exit 1
../ssktool/ssktool --insert sskfile --sskfile sskfile --sskpath sskfile \
		   --key KSK@$ksk/1 && \
  echo "ssktool --insert running with sskfile, path and key!" && exit 1
../ssktool/ssktool --insert sskfile --key KSK@$ksk/1 --content-type text/plain \
		   --metadata sskfile && \
  echo "ssktool --insert running with content-type and metadata!" && exit 1
../ssktool/ssktool --sskpath sskpath \
		   --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF && \
  echo "ssktool --insert running with sskpath only!" && exit 1
../ssktool/ssktool --sskfile sskfile \
		   --dbr freenet:SSK@LCgWj0qabAqxUNKbfI93PCTH9RUPAgM/DSDiF && \
  echo "ssktool --insert running without sskpath!" && exit 1
../ssktool/ssktool --insert sskfile --sskfile sskfile --sskpath test/9 
../ssktool/ssktool --insert sskfile --sskfile sskfile --sskpath test/10 \
		   --content-type text/plain
../ssktool/ssktool --insert sskfile --sskfile sskfile --sskpath test/11 \
		   --metadata metadata
../ssktool/ssktool --insert sskfile --key $ksk/2
../ssktool/ssktool --insert sskfile --key $ksk/3 --content-type text/plain
../ssktool/ssktool --insert sskfile --key $ksk/4 --metadata metadata

exit 0

