/* freenet-utils.h:
 *
 ****************************************************************
 * Copyright (C) 2003 Peter Conrad
 * 
 * See the file "COPYING" for further information about
 * the copyright and warranty status of this work.
 */

#ifndef INCLUDE__WITH_FTP__FREENET_UTILS_H
#define INCLUDE__WITH_FTP__FREENET_UTILS_H

#define DEBUG_FN
 
#ifdef DEBUG_FN
extern void fn_debug(t_uchar *msg);
extern void fn_debug_init();
#else
#define fn_debug(x)
#define fn_debug_init()
#endif

typedef struct {
    t_uchar	*URI_base;
    t_uchar	*URI_string;
    uint	offset;
    uint	increment;
} fn_dbr;

typedef struct {
    t_uchar	*target;
} fn_redirect;

struct fn_dir {
    t_uchar		*fullpath;
    struct fn_entry	*parent;
    struct fn_entry	*first_entry;
    struct fn_entry	*default_entry;
};

struct fn_entry {
    t_uchar		*name;
    struct fn_entry	*next;
    short		type;
    union {
	struct fn_dir	dir;
	fn_dbr		dbr;
	fn_redirect	redirect;
    } e; 
};

typedef struct fn_dir	fn_dir;
typedef struct fn_entry fn_entry;

#define FN_TYPE_DIR		1
#define FN_TYPE_DBR		2
#define FN_TYPE_REDIRECT	3

extern unsigned int parse_env_number(t_uchar *str, unsigned int def_value);
extern int fn_download(t_uchar *key, t_uchar *target, int meta, int htl,
		       int htl_inc, int retries);
extern fn_entry *freeEntry(fn_entry *e);
extern fn_entry *findPath(fn_entry *root, t_uchar *path, int create);
extern fn_entry *parseMetadata(t_uchar *meta);
extern t_uchar *canonicalize_path(t_uchar *path);

#ifdef DEBUG_FN
extern int readLine(t_uchar *buffer, int fd, int n);
extern fn_entry *checkPathElement(fn_entry **e, t_uchar *name);

#endif

#endif  /* INCLUDE__WITH_FTP__FREENET_UTILS_H */

/* tag: freenet-utils.h 1fb3761a6b8d601f6a301fa446a526d2
 */
